#pragma once
#include "LittleFS.h"
#include "ArduinoJson.h"
#define CONFIG_SIZE 0x4E
#define OFFSET_SSID 0x00
#define OFFSET_PASS 0x20
#define OFFSET_IP 0x40
#define OFFSET_SUBNET 0x44
#define OFFSET_GW 0x48
#define OFFSET_MODE 0x4C
#define OFFSET_FAIL_TIMEOUT 0x4D
#define OFFSET_HOLD_TIME 0x4E
class Config
{
private:
    uint8_t *buffer = (uint8_t *)malloc(CONFIG_SIZE);

public:
    Config();
    ~Config();
    const char *SSID = (char *)(buffer + OFFSET_SSID);
    const char *PASS = (char *)(buffer + OFFSET_PASS);  
    uint32_t &ip =  *((uint32_t*)(buffer+OFFSET_IP));
    uint32_t &subnet =  *((uint32_t*)(buffer+OFFSET_SUBNET));
    uint32_t &gw = *((uint32_t*)(buffer+OFFSET_GW));
    uint8_t &mode = *(buffer + OFFSET_MODE);
    uint8_t &fail_timeout = *(buffer+OFFSET_FAIL_TIMEOUT);
    uint8_t &hold_time = *(buffer+OFFSET_HOLD_TIME);
    
    bool loadConfig();
    bool loadBin();
    bool saveBin();
    void print();
    bool setSSID(const char *ssid);
    bool setPASS(const char *pass);
};